/*
 * AUTHOR: ALZAID
 * CREATE DATE: 15-2-2013
 * TITLE: Store
 * PURPOSE: KSU CSC-113 Lab2
 * 
 * */

public class Store {
	private Product[] Items;
	private int nbProduct;

	public Store(int Size) {
		Items = new Product[Size];
		nbProduct = 0;
	}

	public int Search(String pName) {
		for (int i = 0; i < nbProduct; i++)
			if (Items[i].getName().equals(pName))
				return i;
		return -1;
	}

	public boolean Add(Product P) {
		int i = Search(P.getName());

		if (i != -1) {
			Items[i].setQuantity(Items[i].getQuantity() + P.getQuantity());
			return true;
		} else if (nbProduct < Items.length) {
			Items[nbProduct++] = new Product(P.getName(), P.getPrice(),
					P.isIndoor(), P.getQuantity());
			return true;
		}
		return false;
	}

	public void DisplayAll() {
		System.out.println("--------- List of Products ---------- ");
		for (int i = 0; i < nbProduct; i++)
			Items[i].Display();
	}

	public int CountIndoors() {
		int count = 0;
		for (int i = 0; i < nbProduct; i++)
			if (Items[i].isIndoor())
				count++;
		return count;
	}

	public Product[] GetIndoorProducts(double MaxPrice) {
		int index = 0;
		Product[] Indoors = new Product[CountIndoors()];
		for (int i = 0; i < nbProduct; i++)
			if (Items[i].isIndoor() && Items[i].getPrice() < MaxPrice)
				Indoors[index++] = Items[i];
		return Indoors;
	}

	public void SplitProducts(Product[] indoorProducts, Product[] others) {

		int indexIndoor = 0, IndexOther = 0;
		for (int i = 0; i < nbProduct; i++)
			if (Items[i].isIndoor())
				indoorProducts[indexIndoor++] = Items[i];
			else
				others[IndexOther++] = Items[i];

	}

}// class

/*
 * public boolean DeleteProduct(String pName) { int i = Search(pName); if (i !=
 * -1) { Items[i] = Items[--nbProduct]; Items[nbProduct] = null; return true; }
 * return false; }
 */
